// *************** Constants ******************

typedef enum
{
    VisitTypeInit = 0,
    VisitTypeCheck,
    VisitTypeStep,
    VisitTypeRevisit,
    VisitTypeNum
} VisitType;

typedef enum
{
    DotTypeGlobalMax,
    DotTypeLocalMax,
    DotTypeNum
} DotType;

typedef enum
{
    VisTypeNone = 0,
    VisTypeTerrain,
    VisTypeSphericalPolar
} VisualizationType;

/* verbose debug output? */
#define DEBUG 0

// TODO remove this and fix omitted code
#define INCLUDE_OMITTED_CODE 0

#define BIT_COUNT_STATS 0

// TODO remove this, make Makefile target (nkverbose)
//#define FORCE_PRINT_NONPLOTTED_DATA

#ifdef FORCE_PRINT_NONPLOTTED_DATA
#define PRINT_NONPLOTTED_DATA 1
#else
#define PRINT_NONPLOTTED_DATA 0
#endif

#ifdef FORCE_PRINT_POP
#define PRINT_POP 1
#else
#define PRINT_POP 0
#endif

#define MAXN 63                 // TODO: remove this restriction by
                                // implementing data structures for arbitrary n

#define STAGNATION_STEPS 10

#define MIN(x, y) ((x) < (y) ? (x) : (y))
#define MAX(x, y) ((x) < (y) ? (y) : (x))

#define DOUBLE_RAND() ((double)rand () / INT_MAX)

#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x) 

#define AT (__FILE__ ":" TOSTRING (__LINE__))

#pragma GCC system_header   // silences warning for the variadic macro below

#define errorExit(format, ...) \
{                                                      \
    fprintf (stderr, "ERROR at %s: " format "\n", AT, ## __VA_ARGS__); \
    exit(1);                                  \
}
